; #$02 a #$8f 
; 362 ciclos
; 350 ciclos 



!source "charmap.asm"

MAPBASE = ADDR_MAP_DATA
TILEBASE = ADDR_TILESET_DATA
;TILECOLORBASE = ADDR_TILESET_COLOR_DATA
;Inicializacion del test.

; screenOffsets      
MAPPAINT
        LDA #$01
        STA $d020
;       +fillScreen $20
       ; Se restaura el puntero al color
       !ifdef drawColor{
        LDA #$D8
        STA LINEPAINT+5
       }
        ; Calculamos ahora el puntero que tiene que haber en PT_TEMP_MAPOFFHI y PT_TEMP_MAPOFFLO
        ; segun el MAPOFFX y MAPOFFY                   
        ; Se suma todo el offset que tenemos, tanto por el TILEOFFX como por TILEOFFY
        LDA #$04
        ; Se restaura el puntero a pantalla
        STA LINEPAINT+3                
        STA PT_LINESTODRAW ; Y estas son las lineas iniciales a pintar
        ; Se le resta el offy
        SEC
        SBC PT_TILEOFFY        
        STA PT_TMPLINESTODRAW ; Y en el temporal, que son las iniciales a pintar para la primera row de tiles
        LDA PT_TILEOFFX ; Se carga el offx        
        BNE @havetileoffx
        ; Si al cargar el offset en X, hay un numero negativo, no hay que pintar el ultimo tile.Esto se usa en dos sitios, iftile1 y iftile2
        ; En esos dos sitios, si hay que pintar un tile mas, hay que ejecutar un paso mas.
        ; Esto se controla reescribiendo una operacion: CLC o SEC. Si no hay que ejecutar nada para el
        ; ultimo tile, ponemos esas posiciones a "CLC", con lo que el BVC que le sigue hara que salte.
        LDX #$18
        JMP @endtileoffx
@havetileoffx
        LDX #$38
@endtileoffx
        STX ofxtile1
        STX ofxtile2
        
        ; Ahora, por cada TILEOFFY, hay sumar una fila al offset de pintado, y aniadir 4 bytes al puntero
        ; de memoria.
        LDY #$00
        LDX PT_TILEOFFY
        BNE @dobucle
        ; Si no hay offy, la primera linea a pintar va a ser la primera de los tiles correspondientes
        ; El bucle de pintado comienza en cero, y debe detenerse cuando el indice llegue a 4.
        STY drawFullTile+1
        ;STY dtile+1
        LDY #$04 
        STY outBl+1
        ; Listo para pintar la linea.
        ;JMP @initialPointersReady
        TAX
        JMP @checkOffset
@dobucle 
       ; Si hay offy, hay que ajustar varias variables para saltar las primeras lineas de tile.
       ; Para empezar, hay que pintar una linea menos.        
        DEC PT_LINESTODRAW
       ; En Y se va guardando el offset de tile donde va a empezar la primera linea. 
        INY
        INY
        INY
        INY
        CLC
       ; En el acumulador teniamos la cantidad de offset en X inicial.Por cada linea de offsetY, 
       ; añadimos un offset de 40 bytes (una linea de pantalla).
        ADC #40        
        ; En x tenemos el offsetY.El bucle sigue ajustando punteros por cada linea de offsetY
        DEX        
        BNE @dobucle        
        ; En Y esta el offset inicial en Y:
        STY drawFullTile+1
        ; Y sumando 4, esta el indice final en Y:
        INY
        INY
        INY
        INY
        ; Y se almacena en la condicion de salida.
        STY outBl+1
        ; A partir de aqui, que yo sepa, hay que ejecutarlo!!
@checkOffset                
        ; En X esta el offset que define si hay que pintar el primer o el ultimo caracter, en caso de que
        ; el TILEOFFSETX sea distinto de 0.
        STA dbucle+1
        ; Si A sigue a 0, la parte alta de la memoria de pantalla es 04.Si no, es 03.
        CMP #$00
        ; Guardamos un momento el acumulador.
        TAX
        ; Restamos el TILEOFFSETX
        SBC PT_TILEOFFX                
        ; Ahora si que estamos en el primer elemento donde vamos a pintar.Esto se mueve a dtile+1
        STA dtile+1
        ; Recuperamos el acumulador
        

        TXA
        BEQ @noOffset
        LDA #$03        
        STA LINEPAINT+3
!ifdef drawColor{
        LDA #$D7
        STA LINEPAINT+5
}
        
        ; La parte baja debe ser el inverso de lo que tenemos en el acumulador, es decir, 00 - A
        TXA
        EOR #$FF
        CLC
        ADC #$01
        JMP @initialPointersReady
@noOffset
        ; Si no habia offset en absoluto, en el acumulador hay un 0.Si es asi, el primer offset de pantalla es 0400,
        ; y en Y habra cero.        
        LDA #$04
        STA LINEPAINT+3
        ; Lo mismo para la memoria de video
!ifdef drawColor{
        LDA #$D8
        STA LINEPAINT+5
}
        TXA
@initialPointersReady
        ; Se establece la parte baja del inicio del offset de pantalla.
        STA LINEPAINT+1
        
        
drawline1        
       LDY #$00
       JSR FULLLINEPAINT
        
       LDA #MAPLINES
       SEC
       SBC PT_TMPLINESTODRAW
       STA PT_LINESREMAINING
       LDA #$04
       STA PT_LINESTODRAW
       STA PT_TMPLINESTODRAW
fullRowBucle
        ; Se va a la siguiente linea del mapa.
        CLC
        LDA PT_TEMP_MAPOFFLO
        ADC #MAPWIDTH
        STA PT_TEMP_MAPOFFLO
        BCC @endTileRow
        INC PT_TEMP_MAPOFFHI
@endTileRow
        CLC
        LDA #160 ; Bajamos 4 lineas completas de pantalla
        ADC LINEPAINT+1
        STA LINEPAINT+1
        BCC @cont
        INC LINEPAINT+3
!ifdef drawColor{
        INC LINEPAINT+5
}
        CLC
@cont   LDY #$00
        LDA #$00 
        STA dtile+1
        LDA PT_TILEOFFX
        STA dbucle+1
        
        JSR FULLLINEPAINT 
        LDA PT_LINESREMAINING
        SEC
        SBC PT_TMPLINESTODRAW
        BEQ endpaint        
        STA PT_LINESREMAINING
        CMP #$04
        BPL @fullTile
        STA PT_LINESTODRAW
        STA PT_TMPLINESTODRAW
        JMP fullRowBucle
@fullTile
        
        LDA #$04
        STA PT_LINESTODRAW   
        STA PT_TMPLINESTODRAW     
        JMP fullRowBucle
endpaint
        rts




PREPARE
;       
 
;Para calcular el tile a pintar, hay que coger el MAPOFFSET,obtener el indice,
; y multiplicarlo por 16, ya que son tiles de 4x4. En vez de eso, lo que vamos a

; El calculo del puntero a los tiles es : Inicio_tiles + indiceTile * bytes per tile.
; Si Inicio_Tiles comienza en una direccion que termina en $000 (en este caso,$4000),
; y tenemos un maximo de $FF tiles, el tile maximo empezaria en $4FF0.Esto significa
; que, sea cual sea el indice de tile, solo hay que desplazar.No hay carry por ningun lado.
; No tenemos que preocuparnos por TILEBASELO, ya que no tenemos que sumarlo a la 
; multiplicacion: el byte bajo del tile se calcula solo con 16*indice de tile.
; Es por eso que no nos hace falta sumar la parte baja de TILEBASE
!macro setupTilePointer .pointer {
;        LDA (PT_TEMP_MAPOFFLO),Y
;        TAX
;        ASL
;        ASL
;        ASL
;        ASL        
;        STA /1 + 1         
;        TXA                
;        LSR
;        LSR
;        LSR
;        LSR
;        CLC
;        ADC #>TILEBASE
;        STA /1 + 2        
;        INY
        LDA (PT_TEMP_MAPOFFLO),Y        
        TAX
        LDA precalc,X
        TAX
        AND #$0f
        ORA #>TILEBASE
        STA .pointer + 2 
        TXA
        AND #$f0
        STA .pointer + 1
        INY        
}
 
       
        

; Esta funcion calcula los punteros de pantalla donde se deben dibujar los tiles.
; En X e Y esta la parte alta de la pantalla de posicion y de color.
!macro setupAddresses .pointer {
        ADC #$04
        STA .pointer+4
!ifdef drawColor{
        STA .pointer+7
      
        BCC *+5
        INX
        INY
        CLC
}
!ifndef drawColor {
        BCC *+4
        inx
        CLC
}
        STX .pointer+5
!ifdef drawColor{        
        STY .pointer+8
        }
}


FULLLINEPAINT
loadtiles
        
        +setupTilePointer tilecp0
        +setupTilePointer tilecp1
        +setupTilePointer tilecp2
        +setupTilePointer tilecp3
        +setupTilePointer tilecp4
        +setupTilePointer tilecp5
        +setupTilePointer tilecp6
        +setupTilePointer tilecp7
        +setupTilePointer tilecp8
        +setupTilePointer tilecp9
        ; Se comprueba si hay un sexto tile
ofxtile1 CLC
        BCC LINEPAINT
        CLC
        +setupTilePointer tilecp10
        CLC
LINEPAINT
        LDA #$00
        LDX #$04    
    !ifdef drawColor{    
        LDY #$D8
        }
        CLC
        STA tilecp0+4   
!ifdef drawColor{        
        STA tilecp0+7
}
        STX tilecp0+5
!ifdef drawColor{       
        STY tilecp0+8
}
        +setupAddresses tilecp1
        +setupAddresses tilecp2
        +setupAddresses tilecp3
        +setupAddresses tilecp4
        +setupAddresses tilecp5
        +setupAddresses tilecp6
        +setupAddresses tilecp7
        +setupAddresses tilecp8
        +setupAddresses tilecp9
lastTile        
ofxtile2 CLC
        BCC drawFullTile
        CLC
        +setupAddresses tilecp10
        
drawFullTile
         
         LDY #$00         
dtile    LDX #$00
         
dbucle   CPX #$00
         BCS tilecp0
tilecp10  LDA PT_CURTILELO,Y
          STA $0400,X 
!ifdef drawColor{
         STA $0400,X 
}
         JMP tilecp1
tilecp0  LDA PT_CURTILELO,Y
         STA $0400,X   
!ifdef drawColor{
         STA $0400,X 
}
tilecp1  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{ 
         STA $0400,X 
}
tilecp2  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
        STA $0400,X
}
tilecp3  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp4  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp5  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp6  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp7  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp8  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X
}
tilecp9  LDA PT_CURTILELO,Y
         STA $0400,X
!ifdef drawColor{
         STA $0400,X 
}
         INY 
         INX
outBl
         CPY #$00
         BNE dbucle
        
        DEC PT_LINESTODRAW        
        BEQ endDrawTile
         
         ; Se comprueba si ya hemos terminado el tile.
         CLC
         LDA #40
         ADC dtile+1        
         STA dtile+1
         ; Modificamos el control lateral         
         LDA #40
         ADC dbucle+1
         STA dbucle+1         
         ; Se reinicia el contador interno del bucle
         LDA outBl+1
         ADC #$04
         STA outBl+1                                                           
         JMP dtile
endDrawTile         
        ; Se recoloca el offset lateral:
         LDA #$04
         STA outBl+1
         LDA PT_TILEOFFX
         STA dbucle+1
         LDA #$00
         STA drawFullTile+1
         
        RTS
     
premult !by 0,64,128,192




        
        
initializeMapInScreen        
        LDA #<MAPBASE ; Se inicializa PT_MAPOFFLO y PT_MAPOFFHI al comienzo del mapa.
        STA PT_MAPOFFLO        
        LDA #>MAPBASE
        STA PT_MAPOFFHI
        
        
        LDA PT_MAPOFFLO ; Se carga la parte baja del puntero de mapa, en A
        CLC             ; Se limpia el carry, por si acaso
        LDY PT_MAPTILEY ; Se carga el Y de tile, en el registro Y
@addY   BEQ @endY       ; Por cada Y del tile superior izquierdo        
        ADC #MAPWIDTH   ; Añadimos la anchura del mapa
        BCC @nextY       ; Si no hay carry, seguimos sumando
        INC PT_MAPOFFHI ; Si hay carry, sumamos a la parte alta.
        CLC
@nextY  DEY             ; Decrementamos
        JMP @addY
@endY
        ADC PT_MAPTILEX  ; en A tendremos la parte baja.Sumamos ahora X.
        BCC @endcalc    ; Si al sumar, hay overflow, se suma a la parte superior.
        INC PT_MAPOFFHI
@endcalc
        STA PT_MAPOFFLO
          ; En A tenemos PT_MAPOFFLO. Lo metemos en el otro puntero, temporal.        
        STA PT_TEMP_MAPOFFLO
        LDA PT_MAPOFFHI ; Se mete ahora el puntero temporal, 
        STA PT_TEMP_MAPOFFHI
                        
        RTS
precalc
        !by $00,$10,$20,$30,$40,$50,$60,$70,$80,$90,$A0,$B0,$C0,$D0,$E0,$F0,$01,$11,$21,$31,$41,$51,$61,$71,$81,$91,$A1,$B1,$C1,$D1,$E1,$F1,$02,$12,$22,$32,$42,$52,$62,$72,$82,$92,$A2,$B2,$C2,$D2,$E2,$F2,$03,$13,$23,$33,$43,$53,$63,$73,$83,$93,$A3,$B3,$C3,$D3,$E3,$F3,$04,$14,$24,$34,$44,$54,$64,$74,$84,$94,$A4,$B4,$C4,$D4,$E4,$F4,$05,$15,$25,$35,$45,$55,$65,$75,$85,$95,$A5,$B5,$C5,$D5,$E5,$F5,$06,$16,$26,$36,$46,$56,$66,$76,$86,$96,$A6,$B6,$C6,$D6,$E6,$F6,$07,$17,$27,$37,$47,$57,$67,$77,$87,$97,$A7,$B7,$C7,$D7,$E7,$F7,$08,$18,$28,$38,$48,$58,$68,$78,$88,$98,$A8,$B8,$C8,$D8,$E8,$F8,$09,$19,$29,$39,$49,$59,$69,$79,$89,$99,$A9,$B9,$C9,$D9,$E9,$F9,$0A,$1A,$2A,$3A,$4A,$5A,$6A,$7A,$8A,$9A,$AA,$BA,$CA,$DA,$EA,$FA,$0B,$1B,$2B,$3B,$4B,$5B,$6B,$7B,$8B,$9B,$AB,$BB,$CB,$DB,$EB,$FB,$0C,$1C,$2C,$3C,$4C,$5C,$6C,$7C,$8C,$9C,$AC,$BC,$CC,$DC,$EC,$FC,$0D,$1D,$2D,$3D,$4D,$5D,$6D,$7D,$8D,$9D,$AD,$BD,$CD,$DD,$ED,$FD,$0E,$1E,$2E,$3E,$4E,$5E,$6E,$7E,$8E,$9E,$AE,$BE,$CE,$DE,$EE,$FE,$0F,$1F,$2F,$3F,$4F,$5F,$6F,$7F,$8F,$9F,$AF,$BF,$CF,$DF,$EF,$FF
;screenOffsets
;        !by 901,902,903,904,941,942,943,944,981,982,983,984,1021,1022,1023

